-- IMPORTANT! Semicolon (';') at at the end of the line is required!
CREATE INDEX IF NOT EXISTS idx_MESSAGES_conversation_id_AND_order_key_AND_msg_date ON [messages] ([conversation_id], [order_key] DESC, [msg_date] DESC);
CREATE INDEX IF NOT EXISTS idx_MESSAGES_token ON [messages] ([token]);
CREATE INDEX IF NOT EXISTS idx_MESSAGES_seq ON [messages] ([seq]);
CREATE INDEX IF NOT EXISTS idx_MESSAGES_group_id_AND_order_key ON [messages] ([group_id], [order_key] DESC);
CREATE INDEX IF NOT EXISTS idx_MESSAGES_status_AND_msg_date_AND_token ON messages ([status],[msg_date] DESC, [token] DESC);
CREATE INDEX IF NOT EXISTS idx_MESSAGES_extra_mime ON [messages] ([extra_mime]);
CREATE INDEX IF NOT EXISTS part_idx_MESSAGES_unread ON [messages] ([unread]) WHERE unread >0 OR unread = 1;
CREATE INDEX IF NOT EXISTS part_idx_MESSAGES_sync_read ON [messages] ([sync_read]) WHERE sync_read=1 OR sync_read>0;
CREATE INDEX IF NOT EXISTS part_idx_MESSAGES_deleted ON [messages] ([deleted]) WHERE deleted=1 OR deleted=2 OR deleted >0;
CREATE INDEX IF NOT EXISTS part_idx_MESSAGES_extra_status ON [messages] ([extra_status]) WHERE extra_status=0 or  extra_status=1 or  extra_status=2 or  extra_status=4 or  extra_status=5 or  extra_status=6 or  extra_status=7 or extra_status=8 or extra_status=9 or extra_status=10 or extra_status=13;
CREATE INDEX IF NOT EXISTS part_idx_MESSAGES_conversation_id_AND_unread_AND_extra_mime_AND_deleted ON [messages] ( [conversation_id],[unread],[extra_mime],[deleted]) where unread >0 OR unread = 1;
CREATE INDEX IF NOT EXISTS idx_MESSAGES_conversation_id_AND_participant_id_AND_order_key_AND_msg_date ON [messages] ([conversation_id], [participant_id], [order_key] DESC, [msg_date] DESC);
CREATE INDEX IF NOT EXISTS idx_MESSAGES_conversation_type_AND_token_AND_extra_mime ON [messages] ([conversation_type], [token] DESC,[extra_mime]);

CREATE INDEX IF NOT EXISTS idx_MESSAGES_conversation_type_AND_extra_mime ON [messages] ([conversation_type], [extra_mime]);
CREATE INDEX IF NOT EXISTS idx_MESSAGES_timebomb_read_message_time ON [messages] ([timebomb], [read_message_time]);
CREATE INDEX IF NOT EXISTS part_idx_MESSAGES_broadcast_msg_id ON [messages] ([broadcast_msg_id]) WHERE broadcast_msg_id>0;

-- extra_flags & 4294967296 it is MessageExtraFlag.EXTRA_FLAG_PIN_MESSAGE flag
CREATE INDEX IF NOT EXISTS part_idx_MESSAGES_conversation_id_AND_order_key_AND_msg_date_AND_extra_flags ON [messages] ([conversation_id], [order_key] DESC, [msg_date] DESC, [extra_flags]) where (extra_flags & 4294967296) <> 0;
CREATE INDEX IF NOT EXISTS part_idx_MESSAGES_order_key_AND_msg_date_AND_read ON [messages] ([order_key] desc, [msg_date] desc, [unread]) WHERE unread >0 OR unread = 1;
CREATE INDEX IF NOT EXISTS part_idx_MESSAGES_conversation_type_AND_extra_mime_AND_status_AND_extra_uri ON [messages] ([conversation_type], [extra_mime], [status], extra_uri) where (extra_mime=1 OR extra_mime=1003) AND status<>'-1' AND status<>'-2' AND extra_uri IS NULL;
CREATE INDEX IF NOT EXISTS part_idx_MESSAGES_conversation_type01_AND_read1 ON [messages] ([conversation_type], [unread]) WHERE unread >0 OR unread = 1 AND (conversation_type=0 OR conversation_type=1);
CREATE INDEX IF NOT EXISTS part_idx_MESSAGES_token_AND_sync_read ON [messages] ([token] DESC, [sync_read]) WHERE sync_read<>0;
CREATE INDEX IF NOT EXISTS part_idx_MESSAGES_conversation_id_AND_token_AND_read_message_time ON [messages] ([conversation_id], [token], [read_message_time] ) WHERE read_message_time = 0;
CREATE INDEX IF NOT EXISTS idx_MESSAGES_user_id ON [messages] ([user_id]);

CREATE INDEX IF NOT EXISTS part_idx_MESSAGES_community_empty_message ON [messages] ([conversation_id], [extra_mime], [conversation_type], [order_key] DESC) WHERE extra_mime=1007 AND conversation_type=5;
CREATE INDEX IF NOT EXISTS part_idx_MESSAGES_conversation_id_AND_comment_thread_id ON [messages] ([conversation_id], [comment_thread_id]) WHERE comment_thread_id >0;