ALTER TABLE [messages] ADD COLUMN [destination_uri] TEXT;
ALTER TABLE [conversations] ADD COLUMN [background_id] TEXT;

UPDATE [conversations] SET [icon_id] = replace([icon_id], 'http://viber-fake-uri.com/', 'content://com.viber.voip.provider.internal_files/' ) WHERE [icon_id] LIKE 'http://viber-fake-uri.com/%';
UPDATE [participants_info] SET [viber_image] = replace([viber_image], 'http://viber-fake-uri.com/', 'content://com.viber.voip.provider.internal_files/' ) WHERE [viber_image] LIKE 'http://viber-fake-uri.com/%';
UPDATE [messages] SET [extra_uri] = replace([extra_uri], 'http://viber-fake-uri.com/', 'content://com.viber.voip.provider.internal_files/' ) WHERE [extra_uri] LIKE 'http://viber-fake-uri.com/%';
UPDATE [messages] SET [body] = replace([body], 'http://viber-fake-uri.com/', 'content://com.viber.voip.provider.internal_files/' ) WHERE [body] LIKE 'http://viber-fake-uri.com/%';
-- 0# is an escape symbol of '/' in system message becuase '/' symbol is actually a MessageParser separator
UPDATE [messages] SET [body] = replace([body], 'http:0#0#viber-fake-uri.com0#', 'content:0#0#com.viber.voip.provider.internal_files0#' ) WHERE [body] LIKE '%http:0#0#viber-fake-uri.com0#%' AND [extra_mime] == 1000;
-- forwarded Image/Video message from 1on1 with PA is converted to URL message, so 'extra_uri' there doesn't make any sense anymore
UPDATE [messages] SET [extra_uri] = NULL WHERE [extra_mime] == 8;
-- Contact Message contains a formatted message JSON in 'body' so all '/' symbols must be escaped with '\'
UPDATE [messages] SET [body] = replace([body], 'http:\/\/viber-fake-uri.com\/', 'content:\/\/com.viber.voip.provider.internal_files\/' ) WHERE [body] LIKE '%http:\/\/viber-fake-uri.com\/%' AND [extra_mime] == 9;
UPDATE [messages] SET [quoted_message_data] = replace([quoted_message_data], 'http://viber-fake-uri.com/', 'content://com.viber.voip.provider.internal_files/' ) WHERE [quoted_message_data] IS NOT NULL AND [quoted_message_data] LIKE '%http://viber-fake-uri.com/%';
UPDATE [messages] SET [extra_uri] = 'content://com.viber.voip.provider.internal_files/message/vm_v1v2/' || [extra_uri] WHERE [extra_mime] = 2 AND [extra_uri] NOT LIKE 'file:%' AND [extra_uri] NOT LIKE '%.m4a';
UPDATE [messages] SET [extra_uri] = replace([extra_uri], substr([extra_uri], 0, INSTR([extra_uri], '/.ptt/') + 6), 'content://com.viber.voip.provider.internal_files/message/vm_v1v2/') WHERE [extra_mime] = 2 AND [extra_uri] LIKE 'file:%/.ptt/%' AND [extra_uri] NOT LIKE '%.m4a';

-- Recreate 'backgrounds' table because we need to restore 'flags' column and we're going to sync backgrounds config in this version anyway
DROP TABLE IF EXISTS [backgrounds];
CREATE TABLE IF NOT EXISTS [backgrounds] ([_id] INTEGER PRIMARY KEY NOT NULL, [background_id] TEXT DEFAULT '0', package_id INTEGER DEFAULT 0, [flags] INTEGER DEFAULT 0);