CREATE TABLE IF NOT EXISTS backgrounds (_id INTEGER PRIMARY KEY AUTOINCREMENT, background_index INTEGER DEFAULT 0, background_id INTEGER DEFAULT 0, flags INTEGER DEFAULT 0);
ALTER TABLE conversations ADD COLUMN icon_id TEXT;
UPDATE conversations SET icon_id = (SELECT group_conversations_extras.icon_id FROM group_conversations_extras WHERE conversations.group_id = group_conversations_extras.group_id);

SAVEPOINT rm_dupl;
CREATE TABLE [tmp_participant_info_mapping] (_id INTEGER PRIMARY KEY AUTOINCREMENT, correct_id INTEGER, wrong_id INTEGER);
INSERT INTO [tmp_participant_info_mapping] ([correct_id], [wrong_id]) SELECT cr.[_id] AS correct_id, wr.[_id] AS wrong_id FROM [participants_info] cr JOIN [participants_info] wr ON cr.[number] = wr.[number] AND cr.[_id] != wr.[_id] AND cr.[number] != "" AND wr.[number] != "" AND cr.[number] IS NOT NULL AND wr.[number] IS NOT NULL GROUP BY cr.[number];
DELETE FROM [participants_info] WHERE [_id] IN (SELECT [wrong_id] FROM [tmp_participant_info_mapping]);
INSERT OR REPLACE INTO [participants] SELECT p.[_id], p.[conversation_id], m.[correct_id], p.[last_message_id], p.[active], p.[group_role] FROM [participants] p JOIN [tmp_participant_info_mapping] m ON p.[participant_info_id] = m.[wrong_id];
DROP TABLE IF EXISTS [tmp_participant_info_mapping];
RELEASE SAVEPOINT rm_dupl;