﻿--add new column
ALTER TABLE [messages] ADD COLUMN [order_key] LONG;
CREATE INDEX IF NOT EXISTS [MESSAGES_order_key] ON [messages] ([order_key]);
--update order_key with actual value
UPDATE [messages] SET [order_key] = (SELECT [token] FROM [messages] AS [m] WHERE m.[_id] = [messages].[_id]) WHERE conversation_type IN(0, 1);
UPDATE [messages] SET [order_key] = (SELECT [message_global_id] FROM [messages] AS [m] WHERE [m].[_id] = [messages].[_id] AND [m].[conversation_id] = [messages].[conversation_id]) WHERE conversation_type NOT IN(0, 1);
--update order_key for one2one and group conversations
UPDATE [messages] SET [order_key] = (SELECT [token] FROM [messages] AS [m] WHERE [m].[date] <= [messages].[date] ORDER BY [m].[token] DESC LIMIT 1) WHERE (token = 0 OR token IS null) AND conversation_type IN(0, 1);
--update order_key for public chats
UPDATE [messages] SET [order_key] = (SELECT [message_global_id] FROM [messages] AS [m] WHERE [m].[date] <= [messages].[date] AND [m].[conversation_id] = [messages].[conversation_id] ORDER BY [m].[message_global_id] DESC LIMIT 1) WHERE (message_global_id = 0 OR message_global_id IS null) AND conversation_type NOT IN(0, 1);

-- add unique constraint for (object_id, key) in kvdata table
-- before adding a constraint we need to be sure these columns have no duplicates
-- rowid is an alias for INTEGER PRIMARY KEY column
SAVEPOINT kvdata_unique;
DELETE FROM [kvdata] WHERE [rowid] NOT IN (SELECT MIN([rowid]) from [kvdata] GROUP BY [object_id], [key]);
CREATE UNIQUE INDEX IF NOT EXISTS kvdata_objectid_key ON kvdata([object_id], [key]);
RELEASE SAVEPOINT kvdata_unique;