ALTER TABLE messages ADD COLUMN likes_count INTEGER DEFAULT 0;
SAVEPOINT migrate_extras;
UPDATE messages SET likes_count = (SELECT likes_count FROM public_messages_extras WHERE message_token = token), extra_flags = extra_flags | (SELECT (CASE WHEN liked != 0 THEN 1 << 12 ELSE 0 END) FROM public_messages_extras WHERE message_token = token) WHERE EXISTS (SELECT likes_count FROM public_messages_extras WHERE message_token = token);
DROP TRIGGER IF EXISTS trigger_messages_delete;
DROP TABLE IF EXISTS public_messages_extras;
RELEASE SAVEPOINT migrate_extras;

SAVEPOINT create_likes;
CREATE TABLE IF NOT EXISTS messages_likes (_id INTEGER PRIMARY KEY AUTOINCREMENT, message_token LONG NOT NULL, like_token LONG DEFAULT 0, seq INTEGER DEFAULT 0, participant_number TEXT NOT NULL, date LONG DEFAULT 0, read INTEGER DEFAULT 0, sync_read INTEGER DEFAULT 0, status INTEGER DEFAULT 0);
CREATE INDEX IF NOT EXISTS messages_likes_message_token ON messages_likes (message_token);
CREATE TRIGGER IF NOT EXISTS trigger_message_likes_delete AFTER DELETE ON messages BEGIN DELETE FROM messages_likes WHERE message_token = OLD.token; END;
RELEASE SAVEPOINT create_likes;

SAVEPOINT add_extra_filesize;
ALTER TABLE messages ADD COLUMN extra_file_size LONG DEFAULT 0;
RELEASE SAVEPOINT add_extra_filesize;

DELETE FROM messages WHERE messages.extra_mime IN ( 'formatted_follow' );

SAVEPOINT add_msg_info;
ALTER TABLE messages ADD COLUMN msg_info TEXT;
UPDATE messages SET msg_info = description WHERE extra_mime IN ('url_message', 'share_contact');
RELEASE SAVEPOINT add_msg_info;

ALTER TABLE messages ADD COLUMN spans TEXT;

CREATE TABLE [tmp_participant_info_mapping] (_id INTEGER PRIMARY KEY AUTOINCREMENT, correct_id INTEGER, wrong_id INTEGER);
INSERT INTO [tmp_participant_info_mapping] ([correct_id], [wrong_id]) SELECT cr.[_id] AS correct_id, wr.[_id] AS wrong_id FROM [participants_info] cr JOIN [participants_info] wr ON cr.[number] = wr.[number] AND cr.[_id] != wr.[_id] AND cr.[number] != "" AND cr.[encrypted_number] = wr.[encrypted_number] AND cr.[encrypted_number] != "" AND cr.[number] IS NOT NULL AND cr.[encrypted_number] IS NOT NULL GROUP BY cr.[number];
DELETE FROM [participants_info] WHERE [_id] IN (SELECT [wrong_id] FROM [tmp_participant_info_mapping]);
INSERT OR REPLACE INTO [participants] SELECT p.[_id], p.[conversation_id], m.[correct_id], p.[last_message_id], p.[active], p.[group_role] FROM [participants] p JOIN [tmp_participant_info_mapping] m ON p.[participant_info_id] = m.[wrong_id];
UPDATE conversations SET participant_id_1 = (SELECT tmp_participant_info_mapping.correct_id FROM tmp_participant_info_mapping WHERE conversations.participant_id_1 = tmp_participant_info_mapping.wrong_id) WHERE conversations.conversation_type = 0 AND EXISTS (SELECT tmp_participant_info_mapping._id FROM tmp_participant_info_mapping WHERE tmp_participant_info_mapping.wrong_id = conversations.participant_id_1);
DROP TABLE IF EXISTS [tmp_participant_info_mapping];