ALTER TABLE messages ADD COLUMN encryption_params TEXT;
ALTER TABLE [applications] RENAME TO [applications_migration];
CREATE TABLE [applications] ( _id INTEGER PRIMARY KEY NOT NULL, name TEXT, type INTEGER, package_name TEXT, store_id TEXT, url_scheme TEXT, status INTEGER, flags INTEGER DEFAULT 0, last_modified INTEGER DEFAULT (1000*strftime('%s','now')));
-- Int types taken from CGetAppDetails.Type and text types from https://jira.vibelab.net/wiki/display/TS/Global+Registry
-- Int statuses taken from CGetAppDetails.Status and text types from https://jira.vibelab.net/wiki/display/TS/Global+Registry
INSERT OR IGNORE INTO [applications] SELECT am._id, am.app_name, CASE am.type WHEN "game" THEN 0 WHEN "app" THEN 1 WHEN "service" THEN 2 ELSE -1 END, am.app_package_name, NULL, NULL, -1, am.flags, am.last_modified FROM [applications_migration] am WHERE am.app_name IS NOT NULL AND am.app_package_name IS NOT NULL;
-- delete all applications which have unsupported type (it hardly ever happened but just in case)
DELETE FROM [applications] WHERE type < 0;
DROP TABLE IF EXISTS [applications_migration];
CREATE TRIGGER IF NOT EXISTS [trigger_apps_update] AFTER UPDATE ON [applications] BEGIN UPDATE [applications] SET last_modified = (1000*strftime('%s','now')) WHERE _id = old._id; END;