ALTER TABLE [group_conversations_extras] RENAME TO [public_accounts];
ALTER TABLE [public_accounts] ADD COLUMN [website] TEXT;
ALTER TABLE [public_accounts] ADD COLUMN [email] TEXT;
ALTER TABLE [public_accounts] ADD COLUMN [auth_token] TEXT;
ALTER TABLE [public_accounts] ADD COLUMN [category_id] TEXT;
ALTER TABLE [public_accounts] ADD COLUMN [subcategory_id] TEXT;
ALTER TABLE [public_accounts] ADD COLUMN [crm] TEXT;
ALTER TABLE [public_accounts] ADD COLUMN [subscribers_count] INTEGER DEFAULT 0;
ALTER TABLE [public_accounts] ADD COLUMN [subscription_status] INTEGER DEFAULT 0;
ALTER TABLE [public_accounts] ADD COLUMN [invitation_token] INTEGER DEFAULT 0;

-- migrate FLAG_HAS_PUBLIC_ACCOUNT_SUBSCRIPTION flag
UPDATE public_accounts SET subscription_status = 1 WHERE public_account_id IN (SELECT participants_info.member_id FROM conversations LEFT OUTER JOIN participants_info ON (conversations.participant_id_1 = participants_info._id) WHERE (conversations.flags & (1 << 21)) <> 0);
UPDATE conversations SET flags = (flags & ~(1 << 21)) WHERE (flags & (1 << 21)) <> 0;

DROP TRIGGER IF EXISTS trigger_conversations_extras;
DROP TRIGGER IF EXISTS trigger_conversations_delete;
CREATE TRIGGER IF NOT EXISTS trigger_public_account AFTER DELETE ON conversations BEGIN DELETE FROM public_accounts WHERE group_id = OLD.group_id AND (SELECT COUNT(participants_info._id) FROM participants_info WHERE participants_info.member_id=public_accounts.public_account_id )=0; END;
CREATE TRIGGER IF NOT EXISTS trigger_conversations_delete AFTER DELETE ON conversations BEGIN DELETE FROM public_accounts WHERE group_id = OLD.group_id AND  (SELECT COUNT(_id) FROM participants_info WHERE participants_info.member_id=public_accounts.public_account_id )=0; END;

-- Remove background from 1on1 with PA
UPDATE conversations SET background_landscape = NULL, background_portrait = NULL, background_text_color = 0 WHERE (flags & (1 << 19)) <> 0;
